#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef vector<vll> vvll;
#define REP(i, n) for(ll i = 0; i < n; ++i)
#define REPs(i, x, n) for(ll i = x; i < n; ++i)
#define endli "\n"

vector<vector<pair<ll, ll> > >G;
vector<ll> V;
ll n, m;


void dijkstra(){
    V.resize(n+1, -1);
    int a = 1;
    priority_queue <pair<ll,ll>, vector<pair<ll,ll> >, greater<pair<ll, ll> > > D;
    D.push({0, a});
    while(!D.empty() && V[D.top().second] != -1) D.pop();
    if(D.empty()) return;

    int v = D.top().second;
    int vzd = D.top().first;
    V[v] = vzd;
    cout << "here: " << v << " " << vzd << endli;

    for(ll i=0; i < G[v].size(); ++i){
        int w = G[v][i].first, dlz = G[v][i].second;
        if(V[w] != -1) continue;
        D.push({vzd+dlz, w});
    }
}




int main(){
    cin >> n >> m;
    ll a, b;
    vector<pair<ll, ll> > help;
    G.resize(n+1, help);
    for(ll i =0; i < m; i++){
        cin >> a >> b;
        G[a].push_back({1, b});
        G[b].push_back({1, a});
    }
    dijkstra();
    for(ll i =0; i < V.size(); i++){
        cout << V[0] << endl;
    }
    return 0;
}
